/*
 * This file is part of Dave LSD C, thanx to Dave Lindauer.
 *					Sasha
 *
 * This file is included in this release as an alpha version.
 *
 * The only things that have been tested at this time are
 * the series 00xx,01xx,03xx functions
 *
 * Use the rest at your own risk!
 */

#ifndef __DPMI_H
#define __DPMI_H

typedef unsigned ULONG;
typedef unsigned short UWORD;
typedef unsigned char UBYTE;
typedef UWORD SELECTOR;

typedef unsigned char DESCRIPTOR[8];

typedef struct _multiple_descriptor_ {
	UWORD sel;
	DESCRIPTOR desc;
} MULTIPLE_DESCRIPTOR;

typedef union _dpmi_regs_{
	struct {
		ULONG edi,esi,ebp,res1;
		ULONG ebx,edx,ecx,eax;
	} d;
	struct {
		UWORD di,h_di;
		UWORD si,h_si;
		UWORD bp,h_bp;
		UWORD res1,res2;
		UWORD bx,h_bx;
		UWORD dx,h_dx;
		UWORD cx,h_cx;
		UWORD ax,h_ax;
		UWORD flags;
		UWORD es,ds,fs,gs;
		UWORD ip,cs;
		UWORD sp,ss;
	} h;
	struct {
		UBYTE edi[4],esi[4],ebp[4],res1[4];
		UBYTE bl,bh,b_bh1,b_bh2;
		UBYTE dl,dh,b_dh1,b_dh2;
		UBYTE cl,ch,b_ch1,b_ch2;
		UBYTE al,ah,b_ah1,b_ah2;
	} b;
} DPMI_REGS;

typedef struct _dpmi_ver {
	UBYTE	minor,major;
	UWORD	flags;
	UBYTE	processor;
	UBYTE	master_pic;
	UBYTE	slave_pic;
} DPMI_VER;

typedef struct _dpmi_freemem_info_ {
  ULONG largest_block;
  ULONG reserved[11];
} DPMI_FREEMEM_INFO;

typedef ULONG DPMI_MEM_HANDLE;

#ifdef __cplusplus
extern "C" {
#endif

extern int dpmi_alloc_real_memory(SELECTOR *, UWORD *, UWORD);
extern int dpmi_dealloc_real_memory(SELECTOR *);
extern int dpmi_simulate_real_interrupt(UWORD, DPMI_REGS *);

#ifdef __cplusplus
};
#endif

#endif /* __DPMI_H */
