/*
 *    ⫠ (. dirinfo.  debug.zip).
 */

#include <stdio.h>
#include <conio.h>
#include <dos.h>

#include "mc6800.h"
#include "opcode.h"
#include "keyboard.h"
#include "timer.h"
#include "screen.h"
#include "floppy.h"

int IRQrequest = 0;
byte wr_mem[512];

mc6800::mc6800()
{
#ifndef INVOP_IGNORE
	loga = fopen("pyldin.log","wb");
	fprintf(loga, "mc6800 - ꫤ ⨪\n");
#endif
	MEM = new byte[65536];
	BMEM = new byte[4096];
	vMem = MEM;

	memset(MEM, 0, 65535);

	ROMP[0] = &MEM[0xc000];
	ROMP[1] = &MEM[0xc000];
	ROMP[2] = &MEM[0xc000];
	ROMP[3] = &MEM[0xc000];
	ROMP[4] = &MEM[0xc000];
	ROMP[5] = &MEM[0xc000];
	ROMP[6] = &MEM[0xc000];
	ROMP[7] = &MEM[0xc000];
	for (int i = 8; i < 16; i++) {
		ROMP[i] = new byte[8192];
		memset(ROMP[i], 0xff, 8192);
	}
	CurrP = &MEM[0xc000];
	rompage = 0;
	reset();
}

mc6800::~mc6800()
{
#ifndef INVOP_IGNORE
	fclose(loga);
#endif
	delete	MEM;
	delete	BMEM;

	for (int i = 8; i < 16; i++) delete ROMP[i];
}

byte mc6800::memr(word a)
{
	byte t;
	if (a >= 0xf000) return BMEM[a - 0xf000]; //⥭ ⥬ BIOS
	if (a >= 0xc000 && a < 0xe000) return CurrP[a - 0xc000]; //⥭ ROMpage
//	if (a == 0xe601 || a == 0xe605) return vregs[MEM[a-1]];
	if (a == 0xe628) return readKbd(); //⥭  a ()
//	if (a == 0xe629) return piadrb; //⥭  b
	if (a == 0xe62a || a==0xe62e) { // || a==0xe63a || a==0xe63e) {
					//⥭ . a
		t = checkKbd() & 0x80;
		return t | ((led_status & KBD_LED_CAPS)?0:8);
	}
	if (a == 0xe62b) {	//⥭ . b
			t = tick50 | fSpeaker;
			tick50 = 0;
			return t;
	}
	if (a == 0xe6d0)
#ifdef FDC_NATIVE
			return inp(0x3f4);
#else
			return 0x80;
#endif
#ifdef FDC_NATIVE
	if (a == 0xe6c0) return fdctrl;
	if (a == 0xe6d1) return inp(0x3f5);
#endif
//	if (a == 0xe6f0) return rompage; //⥭ ⥪饣  ࠭ ROM
	return MEM[a];
}

void mc6800::memw(word a, byte d)
{
	byte disable_3,old_3s=0;
//if (a == 0x1d4) {
//	fprintf(loga, "write to $ba50 from %04x byte %02x\n", PC, d);
//}
	if (a >= 0xc000 && a < 0xe000) 	//  . ࠭筮 RAM
		if (rompage < 8) { MEM[a] = d; return; }
	if (a == 0xe6f0) {	//  ॣ. ࠭
		d &= 0xf;
		CurrP = ROMP[d];
		rompage = d;
	}
	if (a == 0xe600 || a == 0xe604) d &= 0xf; //롮 ॣ.஫
	if (a == 0xe601 || a == 0xe605) vregs[MEM[a-1]] = d; //   ॣ.஫
	if (a == 0xe629) {
//		piadrb = d;
		cyrMode = (d&1)?0:4;
		setupScr(d);
		viewInfo();
	}
	if (a == 0xe62a || a==0xe62e) { // || a==0xe63a || a==0xe63e) {
		if (d & 0x08) led_status = led_status & ~KBD_LED_CAPS;
		else led_status = led_status | KBD_LED_CAPS;
	//	SetKeyboardLEDs(led_status);
		viewInfo();
	}
	if (a == 0xe62b) {		//  .ॣ b
		old_3s=fSpeaker;
		fSpeaker = d & 0x08;
		if (old_3s!=fSpeaker) disable_3=0; else disable_3=0xff;
		if (fSound==0) {
			if (fSpeaker) {
			   if (disable_3==0) {
				outp(0x61, inp(0x61) | 3);
				outp(0x61, inp(0x61) & ~3);
			   }
				outp(0x61, inp(0x61) | 2);
			} else {
				outp(0x61, inp(0x61) & ~2);
			   if (disable_3==0) {
				outp(0x61, inp(0x61) | 3);
				outp(0x61, inp(0x61) & ~3);
			   }
			}
		}
	}
#ifdef FDC_NATIVE
	if (a == 0xe6c0) {
		fdctrl = d;
		byte temp = ((d&1)?0x4:0) | ((d&8)?0x10:0); // | ((d&4)?0:1);
		outp(0x3f2, temp);
		outp(0x3f7, 2);
	}
	if (a == 0xe6d0) outp(0x3f4, d);
	if (a == 0xe6d1) outp(0x3f5, d);
#endif
	MEM[a] = d;	//   ᭮ 
}

void mc6800::Bcpx(int a, int b)
{
	int wans = a - b;
	int ans = wans & 0xffff;
//	if ((ans &0x8000) != 0) n = 1; else n = 0;
//	if (ans == 0) z = 1; else z = 0;
	TestWord(ans);
	if (((a ^ b) & (a ^ ans) & 0x8000) != 0 ) v = 1; else v = 0;
}

byte mc6800::Blsr(byte a)
{
	byte r = a>>1;
	v = c = a & 1;
	TestByte(r);
	return r;
}

byte mc6800::Basr(byte a)
{
	byte r = (a & 0x80) | (a>>1);
	c = a & 1;
	if (c == (r & 0x80)>>7) v = 0; else v = 1;
	TestByte(r);
	return r;
}

byte mc6800::Basl(byte a)
{
	byte r = a<<1;
	c = (a & 0x80)>>7;
	if (c == (a & 0x40)>>6) v = 0; else v = 1;
	TestByte(r);
	return r;
}

byte mc6800::Bror(byte a)
{
	byte r = (a>>1) | (c<<7);
	c = a & 1;
	if (c == (r & 0x80)>>7) v = 0; else v = 1;
	TestByte(r);
	return r;
}

byte mc6800::Brol(byte a)
{
	byte r = (a<<1) | c;
	c = (a & 0x80)>>7;
	if (c == (a & 0x40)>>6) v = 0; else v = 1;
	TestByte(r);
	return r;
}

byte mc6800::Bsub(byte o1, byte o2)
{

	int op1 = o1;
	int op2 = o2;

	int	wans = op1 - op2;
	int	ans = wans & 0xff;

//	if ((ans & 0x80) != 0) n = 1; else n = 0;
//	if (ans == 0 ) z = 1; else z = 0;
	TestByte(ans);
	if ((wans & 0x100) != 0) c = 1; else c = 0;
	if (((op1 ^ op2) & (op1 ^ ans) & 0x80) != 0 ) v = 1; else v = 0;

	return (byte) ans;
}

byte mc6800::Bsubc(byte o1, byte o2)
{
	int op1 = o1;
	int op2 = o2;

	int	wans = op1 - op2 - (c ? 1 : 0);
	int	ans = wans & 0xff;

//	if ((ans & 0x80) != 0) n = 1; else n = 0;
//	if (ans == 0) z = 1; else z = 0;
	TestByte(ans);
	if ((wans & 0x100) != 0) c = 1; else c = 0;
	if (((op1 ^ op2) & (op1 ^ ans) & 0x80) != 0) v = 1; else v = 0;

	return (byte) ans;
}

byte mc6800::Badd(byte o1, byte o2)
{
	int op1 = o1;
	int op2 = o2;

	int	wans = op1 + op2;
	int	ans = wans & 0xff;

//	if ((ans & 0x80) != 0) n = 1; else n = 0;
//	if (ans == 0) z = 1; else z = 0;
	TestByte(ans);
	if ((wans & 0x100) != 0) c = 1; else c = 0;
	if (((op1 ^ ~op2) & (op1 ^ ans) & 0x80) != 0) v = 1; else v = 0;
	if ((((op1 & 0x0f) + (op2 & 0x0f)) & 0x10) != 0) h = 1; else h = 0;
	return (byte) ans;
}

byte mc6800::Baddc(byte o1, byte o2)
{
	int op1 = o1;
	int op2 = o2;

	int	wans = op1 + op2 + (c ? 1 : 0);
	int	ans = wans & 0xff;

//	if ((ans & 0x80) != 0) n = 1; else n = 0;
//	if (ans == 0) z = 1; else z = 0;
	TestByte(ans);
	if ((wans & 0x100) != 0) c = 1; else c = 0;
	if (((op1 ^ ~op2) & (op1 ^ ans) & 0x80) != 0) v = 1; else v = 0;
	if ((((op1 & 0x0f) + (op2 & 0x0f) + (c ? 1 : 0)) & 0x10) != 0) h = 1; else h = 0;
	return (byte) ans;
}

void mc6800::Bdaa()
{
	byte	incr = 0;
	byte	carry = c;

	if (h || ((A & 0x0f) > 0x09)) incr |= 0x06;
	if (carry || (A > 0x99)) incr |= 0x60;
	if (A > 0x99) carry = 1;
	A = Badd(A, incr);
	c = carry;
}

byte mc6800::NextByte()
{
	return memr(PC++);
}

void mc6800::FetchAddr()
{
	EAR = NextByte() << 8;
	EAR = EAR | NextByte();
}

void mc6800::TestByte(byte b)
{
	if (b == 0) z = 1; else z = 0;
	if (b & 0x80) n = 1; else n = 0;
}

void mc6800::TestWord(word w)
{
	if (w == 0) z = 1; else z = 0;
	if (w & 0x8000) n = 1; else n = 0;
}

void mc6800::Branch()
{
	if ((EAR & 0x80) == 0) EAR &= 0xFF; else EAR |= 0xFF00;
	PC += EAR;
}

int mc6800::step()
{
	byte oc, oh, t;
	word ofs, r16;

//if (PC==0xd7c7) fprintf(loga, "%04x : %02x   a=%02x\n", PC, memr(PC), A);

	if (fWai == 1 && IRQrequest == 0) return NOERROR;
	else if (fWai == 1 && IRQrequest != 0) {
	//		i = 1;
//		if (tick50 = 0x80) fTick = 0;
		fWai = 0;
//		IRQrequest = 0;
		return NOERROR;
	} else if (IRQrequest != 0 && i == 0) {
		t = (c?1:0)|(v?2:0)|(z?4:0)|(n?8:0)|(i?16:0)|(h?32:0)|0xc0;
		memw(SP--, PC&0xff); memw(SP--, PC>>8);
		memw(SP--, X&0xff); memw(SP--, X>>8);
		memw(SP--, A);
		memw(SP--, B);
		memw(SP--, t);
		PC = memr(0xfff8)<<8; PC |= memr(0xfff9);

		IRQrequest = 0;

//		fTick = 0; tick50 = 0x80;

	//	if (tick50 = 0x80) fTick = 0;

	//		i = 1;
		return NOERROR;
	}
	byte opnum = memr(PC++);
	switch (opnum) {
#ifndef INVOP_IGNORE
		case NOP:	break;
#endif
		case CLC:	c = 0; break;
		case CLI:	i = 0; break;
		case CLV:	v = 0; break;
		case SEC:	c = 1; break;
		case SEI:	i = 1; break;
		case SEV:	v = 1; break;
		case TPA:	A = (c?1:0)|(v?2:0)|(z?4:0)|(n?8:0)|(i?16:0)|(h?32:0)|0xc0; break;
		case TAP:	c=(A&1)!=0; v=(A&2)!=0; z=(A&4)!=0; n=(A&8)!=0; i=(A&16)!=0; h=(A&32)!=0; break;
		case TBA:	A = B; v = 0; TestByte(A); break;
		case TAB:	B = A; v = 0; TestByte(A); break;
		case TSX:	X = SP + 1; break;
		case TXS:	SP = X - 1; break;

		case DAA:	oh=h; Bdaa(); h=oh; break;

		case PSHA:	memw(SP--, A); break;
		case PSHB:	memw(SP--, B); break;
		case PULA:	A = memr(++SP); break;
		case PULB:	B = memr(++SP); break;

		case DEC_idx:	ofs=NextByte()+X; oc=c; memw(ofs,Bsub(memr(ofs),1)); c=oc; break;
		case DEC:	FetchAddr(); oc=c; memw(EAR, Bsub(memr(EAR),1)); c=oc; break;
		case DECA:	oc=c; A=Bsub(A,1); c=oc; break;
		case DECB:	oc=c; B=Bsub(B,1); c=oc; break;
		case DES:	SP--; break;
		case DEX:	X--; z = X?0:1; break;

		case INC_idx:	ofs=NextByte()+X; oh=h; oc=c; memw(ofs,Badd(memr(ofs),1)); c=oc; h=oh; break;
		case INC:	FetchAddr(); oh=h; oc=c; memw(EAR, Badd(memr(EAR),1)); c=oc; h=oh; break;
		case INCA:	oh=h; oc=c; A=Badd(A,1); c=oc; h=oh; break;
		case INCB:	oh=h; oc=c; B=Badd(B,1); c=oc; h=oh; break;
		case INS:	SP++; break;
		case INX:	X++; z = X?0:1; break;

		case CLR_idx:	memw(NextByte()+X, 0); n = v = c = 0; z = 1; break;
		case CLR:	FetchAddr(); memw(EAR, 0); n = v = c = 0; z = 1; break;
		case CLRA:	A = n = v = c = 0; z = 1; break;
		case CLRB:	B = n = v = c = 0; z = 1; break;

		case COM_idx: ofs = NextByte()+X; memw(ofs, ~memr(ofs)); c = 1; v = 0; TestByte(memr(ofs)); break;
		case COM:	FetchAddr(); memw(EAR, ~memr(EAR)); c = 1; v = 0; TestByte(memr(EAR)); break;
		case COMA:	A = ~A; c = 1; v = 0; TestByte(A); break;
		case COMB:	B = ~B; c = 1; v = 0; TestByte(B); break;

		case NEG_idx: ofs = NextByte()+X; memw(ofs, Bsub(0, memr(ofs))); break;
		case NEG:	FetchAddr(); memw(EAR, Bsub(0, memr(EAR))); break;
		case NEGA:	A = Bsub(0, A); break;
		case NEGB:	B = Bsub(0, B); break;

		case LDAA_imm: A = NextByte(); v = 0; TestByte(A); break;
		case LDAA_dir: A = memr(NextByte()); v = 0; TestByte(A); break;
		case LDAA_idx: A = memr(X + NextByte()); v = 0; TestByte(A); break;
		case LDAA:	FetchAddr(); A = memr(EAR); v = 0; TestByte(A); break;
		case LDAB_imm: B = NextByte(); v = 0; TestByte(B); break;
		case LDAB_dir: B = memr(NextByte()); v = 0; TestByte(B); break;
		case LDAB_idx: B = memr(X + NextByte()); v = 0; TestByte(B); break;
		case LDAB:	FetchAddr(); B = memr(EAR); v = 0; TestByte(B); break;

		case LDS_imm: FetchAddr(); SP = EAR; v = 0; TestWord(SP); break;
		case LDS_dir: ofs=NextByte(); SP = memr(ofs) << 8; SP |= memr(ofs + 1); v = 0; TestWord(SP); break;
		case LDS_idx: ofs=X+NextByte(); SP = memr(ofs) << 8; SP |= memr(ofs + 1); v = 0; TestWord(SP); break;
		case LDS:	FetchAddr(); SP = memr(EAR) << 8; SP |= memr(EAR + 1); v = 0; TestWord(SP); break;
		case LDX_imm: FetchAddr(); X = EAR; v = 0; TestWord(X); break;
		case LDX_dir: ofs=NextByte(); X = memr(ofs) << 8; X |= memr(ofs + 1); v = 0; TestWord(X); break;
		case LDX_idx: ofs=X+NextByte(); X=memr(ofs)<<8; X|=memr(ofs+1); v = 0; TestWord(X); break;
		case LDX:	FetchAddr(); X = memr(EAR) << 8; X |= memr(EAR + 1); v = 0; TestWord(X); break;

		case STAA_dir: memw(NextByte(), A); v = 0; TestByte(A); break;
		case STAA_idx: memw(X + NextByte(), A); v = 0; TestByte(A); break;
		case STAA:	FetchAddr(); memw(EAR, A); v = 0; TestByte(A); break;
		case STAB_dir: memw(NextByte(), B); v = 0; TestByte(B); break;
		case STAB_idx: memw(X + NextByte(), B); v = 0; TestByte(B); break;
		case STAB:	FetchAddr(); memw(EAR, B); v = 0; TestByte(B); break;

		case STS_dir: ofs=NextByte(); memw(ofs,SP>>8); memw(ofs+1, SP&0xff); v=0; TestWord(SP); break;
		case STS_idx: ofs=X+NextByte(); memw(ofs,SP>>8); memw(ofs+1,SP&0xff); v=0; TestWord(SP); break;
		case STS:	FetchAddr(); memw(EAR,SP>>8); memw(EAR+1,SP&0xff); v=0; TestWord(SP); break;
		case STX_dir: ofs=NextByte(); memw(ofs,X>>8); memw(ofs+1, X&0xff); v=0; TestWord(X); break;
		case STX_idx: ofs=X+NextByte(); memw(ofs,X>>8); memw(ofs+1,X&0xff); v=0; TestWord(X); break;
		case STX:	FetchAddr(); memw(EAR,X>>8); memw(EAR+1,X&0xff); v=0; TestWord(X); break;

		case ABA:	A = Badd(A, B); break;

		case ADCA_imm: A = Baddc(A, NextByte()); break;
		case ADCA_dir: A = Baddc(A, memr(NextByte())); break;
		case ADCA_idx: A = Baddc(A, memr(X + NextByte())); break;
		case ADCA:	FetchAddr(); A = Baddc(A, memr(EAR)); break;
		case ADCB_imm: B = Baddc(B, NextByte()); break;
		case ADCB_dir: B = Baddc(B, memr(NextByte())); break;
		case ADCB_idx: B = Baddc(B, memr(X + NextByte())); break;
		case ADCB:	FetchAddr(); B = Baddc(B, memr(EAR)); break;

		case ADDA_imm: A = Badd(A, NextByte()); break;
		case ADDA_dir: A = Badd(A, memr(NextByte())); break;
		case ADDA_idx: A = Badd(A, memr(X + NextByte())); break;
		case ADDA:	FetchAddr(); A = Badd(A, memr(EAR)); break;
		case ADDB_imm: B = Badd(B, NextByte()); break;
		case ADDB_dir: B = Badd(B, memr(NextByte())); break;
		case ADDB_idx: B = Badd(B, memr(X + NextByte())); break;
		case ADDB:	FetchAddr(); B = Badd(B, memr(EAR)); break;

		case SBA:	A = Bsub(A, B); break;

		case SBCA_imm: A = Bsubc(A, NextByte()); break;
		case SBCA_dir: A = Bsubc(A, memr(NextByte())); break;
		case SBCA_idx: A = Bsubc(A, memr(X + NextByte())); break;
		case SBCA:	FetchAddr(); A = Bsubc(A, memr(EAR)); break;
		case SBCB_imm: B = Bsubc(B, NextByte()); break;
		case SBCB_dir: B = Bsubc(B, memr(NextByte())); break;
		case SBCB_idx: B = Bsubc(B, memr(X + NextByte())); break;
		case SBCB:	FetchAddr(); B = Bsubc(B, memr(EAR)); break;

		case SUBA_imm: A = Bsub(A, NextByte()); break;
		case SUBA_dir: A = Bsub(A, memr(NextByte())); break;
		case SUBA_idx: A = Bsub(A, memr(X + NextByte())); break;
		case SUBA:	FetchAddr(); A = Bsub(A, memr(EAR)); break;
		case SUBB_imm: B = Bsub(B, NextByte()); break;
		case SUBB_dir: B = Bsub(B, memr(NextByte())); break;
		case SUBB_idx: B = Bsub(B, memr(X + NextByte())); break;
		case SUBB:	FetchAddr(); B = Bsub(B, memr(EAR)); break;

		case ANDA_imm: A &= NextByte(); v = 0; TestByte(A); break;
		case ANDA_dir: A &= memr(NextByte()); v = 0; TestByte(A); break;
		case ANDA_idx: A &= memr(X + NextByte()); v = 0; TestByte(A); break;
		case ANDA:	FetchAddr(); A &= memr(EAR); v = 0; TestByte(A); break;
		case ANDB_imm: B &= NextByte(); v = 0; TestByte(B); break;
		case ANDB_dir: B &= memr(NextByte()); v = 0; TestByte(B); break;
		case ANDB_idx: B &= memr(X + NextByte()); v = 0; TestByte(B); break;
		case ANDB:	FetchAddr(); B &= memr(EAR); v = 0; TestByte(B); break;

		case ORAA_imm: A |= NextByte(); v = 0; TestByte(A); break;
		case ORAA_dir: A |= memr(NextByte()); v = 0; TestByte(A); break;
		case ORAA_idx: A |= memr(X + NextByte()); v = 0; TestByte(A); break;
		case ORAA:	FetchAddr(); A |= memr(EAR); v = 0; TestByte(A); break;
		case ORAB_imm: B |= NextByte(); v = 0; TestByte(B); break;
		case ORAB_dir: B |= memr(NextByte()); v = 0; TestByte(B); break;
		case ORAB_idx: B |= memr(X + NextByte()); v = 0; TestByte(B); break;
		case ORAB:	FetchAddr(); B |= memr(EAR); v = 0; TestByte(B); break;

		case EORA_imm: A ^= NextByte(); v = 0; TestByte(A); break;
		case EORA_dir: A ^= memr(NextByte()); v = 0; TestByte(A); break;
		case EORA_idx: A ^= memr(X + NextByte()); v = 0; TestByte(A); break;
		case EORA:	FetchAddr(); A ^= memr(EAR); v = 0; TestByte(A); break;
		case EORB_imm: B ^= NextByte(); v = 0; TestByte(B); break;
		case EORB_dir: B ^= memr(NextByte()); v = 0; TestByte(B); break;
		case EORB_idx: B ^= memr(X + NextByte()); v = 0; TestByte(B); break;
		case EORB:	FetchAddr(); B ^= memr(EAR); v = 0; TestByte(B); break;

		case LSR_idx: ofs=X+NextByte(); memw(ofs, Blsr(memr(ofs))); break;
		case LSR: FetchAddr(); memw(EAR, Blsr(memr(EAR))); break;
		case LSRA: A = Blsr(A); break;
		case LSRB: B = Blsr(B); break;

		case ASR_idx: ofs=X+NextByte(); memw(ofs, Basr(memr(ofs))); break;
		case ASR: FetchAddr(); memw(EAR, Basr(memr(EAR))); break;
		case ASRA: A = Basr(A); break;
		case ASRB: B = Basr(B); break;

		case ASL_idx: ofs=X+NextByte(); memw(ofs, Basl(memr(ofs))); break;
		case ASL: FetchAddr(); memw(EAR, Basl(memr(EAR))); break;
		case ASLA: A = Basl(A); break;
		case ASLB: B = Basl(B); break;

		case ROR_idx: ofs=X+NextByte(); memw(ofs, Bror(memr(ofs))); break;
		case ROR: FetchAddr(); memw(EAR, Bror(memr(EAR))); break;
		case RORA: A = Bror(A); break;
		case RORB: B = Bror(B); break;

		case ROL_idx: ofs=X+NextByte(); memw(ofs, Brol(memr(ofs))); break;
		case ROL: FetchAddr(); memw(EAR, Brol(memr(EAR))); break;
		case ROLA: A = Brol(A); break;
		case ROLB: B = Brol(B); break;

		case BITA_imm: v = 0; TestByte(A & NextByte()); break;
		case BITA_dir: v = 0; TestByte(A & memr(NextByte())); break;
		case BITA_idx: v = 0; TestByte(A & memr(X + NextByte())); break;
		case BITA: FetchAddr(); v = 0; TestByte(A & memr(EAR)); break;
		case BITB_imm: v = 0; TestByte(B & NextByte()); break;
		case BITB_dir: v = 0; TestByte(B & memr(NextByte())); break;
		case BITB_idx: v = 0; TestByte(B & memr(X + NextByte())); break;
		case BITB: FetchAddr(); v = 0; TestByte(B & memr(EAR)); break;

		case CBA:	Bsub(A, B); break;

		case CMPA_imm: Bsub(A, NextByte()); break;
		case CMPA_dir: Bsub(A, memr(NextByte())); break;
		case CMPA_idx: Bsub(A, memr(X + NextByte())); break;
		case CMPA:	FetchAddr(); Bsub(A, memr(EAR)); break;
		case CMPB_imm: Bsub(B, NextByte()); break;
		case CMPB_dir: Bsub(B, memr(NextByte())); break;
		case CMPB_idx: Bsub(B, memr(X + NextByte())); break;
		case CMPB:	FetchAddr(); Bsub(B, memr(EAR)); break;

		case CPX_imm: FetchAddr(); Bcpx(X, EAR); break;
		case CPX_dir: ofs=NextByte(); r16=memr(ofs)<<8; r16|=memr(ofs+1); Bcpx(X, r16); break;
		case CPX_idx: ofs=NextByte()+X; r16=memr(ofs)<<8; r16|=memr(ofs+1); Bcpx(X, r16); break;
		case CPX: FetchAddr(); r16=memr(EAR)<<8; r16|=memr(EAR+1); Bcpx(X, r16); break;

		case TST_idx: c = v = 0; TestByte(memr(X + NextByte())); break;
		case TST:	FetchAddr(); c = v = 0; TestByte(memr(EAR)); break;
		case TSTA: c = v = 0; TestByte(A); break;
		case TSTB: c = v = 0; TestByte(B); break;

		case BCC: EAR=NextByte(); if (c==0) Branch(); break;
		case BCS: EAR=NextByte(); if (c==1) Branch(); break;
		case BEQ: EAR=NextByte(); if (z==1) Branch(); break;
		case BGE: EAR=NextByte(); if ((n^v)==0) Branch(); break;
		case BGT: EAR=NextByte(); if ((z|(n^v))==0) Branch(); break;
		case BHI: EAR=NextByte(); if ((c|z)==0) Branch(); break;
		case BLE: EAR=NextByte(); if ((z|(n^v))==1) Branch(); break;
		case BLS: EAR=NextByte(); if ((c|z)==1) Branch(); break;
		case BLT: EAR=NextByte(); if ((n^v)==1) Branch(); break;
		case BMI: EAR=NextByte(); if (n==1) Branch(); break;
		case BNE: EAR=NextByte(); if (z==0) Branch(); break;
		case BPL: EAR=NextByte(); if (n==0) Branch(); break;
		case BVC: EAR=NextByte(); if (v==0) Branch(); break;
		case BVS: EAR=NextByte(); if (v==1) Branch(); break;

		case BRA: EAR=NextByte(); Branch(); break;
		case BSR: EAR=NextByte(); memw(SP--, PC&0xff); memw(SP--, PC>>8); Branch(); break;

		case JMP_idx: PC = X + NextByte(); break;
		case JMP: FetchAddr(); PC = EAR; break;
		case JSR_idx: EAR = PC + 1; memw(SP--, EAR&0xff); memw(SP--, EAR>>8); PC=X+NextByte(); break;
		case JSR: FetchAddr(); memw(SP--, PC&0xff); memw(SP--, PC>>8); PC=EAR; break;

		case RTS: PC = memr(++SP)<<8; PC |= memr(++SP); break;

		case RTI:	t = memr(++SP);
				c=(t&1)!=0; v=(t&2)!=0; z=(t&4)!=0; n=(t&8)!=0; i=(t&16)!=0; h=(t&32)!=0;
				B = memr(++SP);
				A = memr(++SP);
				X = memr(++SP)<<8; X |= memr(++SP);
				PC = memr(++SP)<<8; PC |= memr(++SP);
				break;

		case SWI:
#ifndef FDC_NATIVE
				if (memr(PC) != 0x17) {
#endif
				t = (c?1:0)|(v?2:0)|(z?4:0)|(n?8:0)|(i?16:0)|(h?32:0)|0xc0;
				memw(SP--, PC&0xff); memw(SP--, PC>>8);
				memw(SP--, X&0xff); memw(SP--, X>>8);
				memw(SP--, A);
				memw(SP--, B);
				memw(SP--, t);
				PC = memr(0xfffa)<<8; PC |= memr(0xfffb);
#ifndef FDC_NATIVE
				} else {
					PC++;
					INT17emulator();
				}
#endif
				i = 1; break;

		case WAI:
/*
			i = 1;
			t = (c?1:0)|(v?2:0)|(z?4:0)|(n?8:0)|(i?16:0)|(h?32:0)|0xc0;
			memw(SP--, PC&0xff); memw(SP--, PC>>8);
			memw(SP--, X&0xff); memw(SP--, X>>8);
			memw(SP--, A);
			memw(SP--, B);
			memw(SP--, t);
			PC = memr(0xfff8)<<8; PC |= memr(0xfff9);
 */
			i = fWai = 1;
			break;

#ifdef EM68COMPATIBLY
		case 0x41: putchar(A); break;
#ifdef WIN32
		case 0x51: A = _getch(); break;
#else
		case 0x51: A = getchar(); break;
#endif
#endif
		default: {	// NOP (0x01)  ४
#ifndef INVOP_IGNORE
			PC--;
			fprintf(loga, "invalid opcode at %04x byte %02x\n", PC, opnum);
			fprintf(loga, "X = %04x\nSP=%04x\nA=%02x\nB=%02x\n", X, SP, A, B);
			fprintf(loga, "H=%1x I=%1x N=%1x Z=%1x V=%1x C=%1x\n", h, i, n, z, v, c);
			FILE *zz = fopen("dump.bin", "wb");
			for (word i = 0; i < 65535; i++) {
				t = memr(i);
				fwrite(&t, 1, 1, zz);
			}
			fclose(zz);
			return INVALIDOPCODE;
#endif
		}
	}
	return NOERROR;
}

void mc6800::INT17emulator()
{
	word bukva, i2;

//	if (A > 1 && A <= 4) {
//		led_status |= KBD_LED_SCROLL;
//		SetKeyboardLEDs(led_status);
//	}
//	byte oldA = A;
	int devs  = memr(X);
	int track = memr(X+1);
	int head  = memr(X+2);
	int sect  = memr(X+3);
	int offs  = (memr(X+4) << 8) | memr(X+5);
	bukva = MEM[0xed20]<<8; bukva |= MEM[0xed21];
	if (m601a == 0) bukva += 81; else bukva += 159;
	switch(A) {
		case 0x80:
		case 0: A = init765(); break;
		case 1:	MEM[bukva] = 0x52;
			if (m601a == 0) refreshScr(); else refreshScr_A();
			A = readSector(devs, track, sect, head, MEM + offs);
			MEM[bukva] = 0x20; break;
		case 2:	MEM[bukva] = 0x57;
			if (m601a == 0) refreshScr(); else refreshScr_A();
			for (i2=0; i2<512; i2++) wr_mem[i2]=memr(offs+i2);
			A = writeSector(devs, track, sect, head, wr_mem);
			MEM[bukva] = 0x20; break;
		case 3:	MEM[bukva] = 0x53;
			if (m601a == 0) refreshScr(); else refreshScr_A();
			A = readSector(devs, track, sect, head, wr_mem);
			MEM[bukva] = 0x20; break;
		case 4:	MEM[bukva] = 0x46;
			if (m601a == 0) refreshScr(); else refreshScr_A();
			A = formaTrack(devs, track, head);
			MEM[bukva] = 0x20; break;
// 㭪 0xff -  몫  ᪮
// case 0xff: outp(0x3f2, inp(0x3f2) & ~0x30); A = 0; break;
// ( , .. 㤥 ᨫ쭮 ମ,  ⮬   
// 㦭 - IBM'᪨ int $13 ᠬ 몫砥 ).
		default: A = 0; break;
	}
//	if (oldA > 1 && oldA <= 4) {
//		led_status ^= KBD_LED_SCROLL;
//		SetKeyboardLEDs(led_status);
//	}
//	fprintf(loga, "INT 17 in pc=%04x, a=%02x\n", PC, A);
}

#ifndef INVOP_IGNORE
void mc6800::un_ext(char *buf, char *op, word adr)
{
	sprintf(buf, "%04x: %02x %02x %02x	%s	$%04x", adr, memr(adr), memr(adr+1), memr(adr+2),
			op, memr(adr+1)*256+memr(adr+2));
}

void mc6800::un_idx(char *buf, char *op, word adr)
{
	sprintf(buf, "%04x: %02x %02x		%s	$%02x,x", adr, memr(adr), memr(adr+1),
			op, memr(adr+1));
}

void mc6800::un_dir(char *buf, char *op, word adr)
{
	sprintf(buf, "%04x: %02x %02x		%s	$%02x", adr, memr(adr), memr(adr+1),
			op, memr(adr+1));
}

void mc6800::un_imm(char *buf, char *op, word adr)
{
	sprintf(buf, "%04x: %02x %02x		%s	#$%02x", adr, memr(adr), memr(adr+1),
			op, memr(adr+1));
}

void mc6800::un_imm_w(char *buf, char *op, word adr)
{
	sprintf(buf, "%04x: %02x %02x %02x	%s	#$%04x", adr, memr(adr), memr(adr+1), memr(adr+2),
			op, memr(adr+1)*256+memr(adr+2));
}

void mc6800::un_rel(char *buf, char *op, word adr)
{
	word o = memr(adr+1);
	if ((o & 0x80) == 0) o &= 0xFF; else o |= 0xFF00;
	o = o + adr + 2;

	sprintf(buf, "%04x: %02x %02x		%s	$%04x", adr, memr(adr), memr(adr+1),
			op, o);
}

void mc6800::un_imp(char *buf, char *op, word adr)
{
	sprintf(buf, "%04x: %02x		%s", adr, memr(adr), op);
}

char *mc6800::disasm(word adr, char *buf)
{
	byte opnum = memr(adr);
	switch (opnum){
		case NOP:	un_imp(buf, "NOP", adr); break;
		case CLC:	un_imp(buf, "CLC", adr); break;
		case CLI:	un_imp(buf, "CLC", adr); break;
		case CLV:	un_imp(buf, "CLV", adr); break;
		case SEC:	un_imp(buf, "SEC", adr); break;
		case SEI:	un_imp(buf, "SEI", adr); break;
		case SEV:	un_imp(buf, "SEV", adr); break;
		case TPA:	un_imp(buf, "TPA", adr); break;
		case TAP:	un_imp(buf, "TAP", adr); break;
		case TBA:	un_imp(buf, "TBA", adr); break;
		case TAB:	un_imp(buf, "TAB", adr); break;
		case TSX:	un_imp(buf, "TSX", adr); break;
		case TXS:	un_imp(buf, "TXS", adr); break;

		case DAA:	un_imp(buf, "DAA", adr); break;

		case PSHA:	un_imp(buf, "PSHA", adr); break;
		case PSHB:	un_imp(buf, "PSHB", adr); break;
		case PULA:	un_imp(buf, "PULA", adr); break;
		case PULB:	un_imp(buf, "PULB", adr); break;

		case DEC_idx:	un_idx(buf, "DEC", adr); break;
		case DEC:	un_ext(buf, "DEC", adr); break;
		case DECA:	un_imp(buf, "DECA", adr); break;
		case DECB:	un_imp(buf, "DECB", adr); break;
		case DES:	un_imp(buf, "DES", adr); break;
		case DEX:	un_imp(buf, "DEX", adr); break;

		case INC_idx:	un_idx(buf, "INC", adr); break;
		case INC:	un_ext(buf, "INC", adr); break;
		case INCA:	un_imp(buf, "INCA", adr); break;
		case INCB:	un_imp(buf, "INCB", adr); break;
		case INS:	un_imp(buf, "INS", adr); break;
		case INX:	un_imp(buf, "INX", adr); break;

		case CLR_idx:	un_idx(buf, "CLR", adr); break;
		case CLR:	un_ext(buf, "CLR", adr); break;
		case CLRA:	un_imp(buf, "CLRA", adr); break;
		case CLRB:	un_imp(buf, "CLRB", adr); break;

		case COM_idx:	un_idx(buf, "COM", adr); break;
		case COM:	un_ext(buf, "COM", adr); break;
		case COMA:	un_imp(buf, "COMA", adr); break;
		case COMB:	un_imp(buf, "COMB", adr); break;

		case NEG_idx:	un_idx(buf, "NEG", adr); break;
		case NEG:	un_ext(buf, "NEG", adr); break;
		case NEGA:	un_imp(buf, "NEG", adr); break;
		case NEGB:	un_imp(buf, "NEG", adr); break;

		case LDAA_imm:	un_imm(buf, "LDAA", adr); break;
		case LDAA_dir:	un_dir(buf, "LDAA", adr); break;
		case LDAA_idx:	un_idx(buf, "LDAA", adr); break;
		case LDAA:	un_ext(buf, "LDAA", adr); break;
		case LDAB_imm:	un_imm(buf, "LDAB", adr); break;
		case LDAB_dir:	un_dir(buf, "LDAB", adr); break;
		case LDAB_idx:	un_idx(buf, "LDAB", adr); break;
		case LDAB:	un_ext(buf, "LDAB", adr); break;

		case LDS_imm:	un_imm_w(buf, "LDS", adr); break;
		case LDS_dir:	un_dir(buf, "LDS", adr); break;
		case LDS_idx:	un_idx(buf, "LDS", adr); break;
		case LDS:	un_ext(buf, "LDS", adr); break;
		case LDX_imm:	un_imm_w(buf, "LDX", adr); break;
		case LDX_dir:	un_dir(buf, "LDX", adr); break;
		case LDX_idx:	un_idx(buf, "LDX", adr); break;
		case LDX:	un_ext(buf, "LDX", adr); break;

		case STAA_dir:	un_dir(buf, "STAA", adr); break;
		case STAA_idx:	un_idx(buf, "STAA", adr); break;
		case STAA:	un_ext(buf, "STAA", adr); break;
		case STAB_dir:	un_dir(buf, "STAB", adr); break;
		case STAB_idx:	un_idx(buf, "STAB", adr); break;
		case STAB:	un_ext(buf, "STAB", adr); break;

		case STS_dir:	un_dir(buf, "STS", adr); break;
		case STS_idx:	un_idx(buf, "STS", adr); break;
		case STS:	un_ext(buf, "STS", adr); break;
		case STX_dir:	un_dir(buf, "STX", adr); break;
		case STX_idx:	un_idx(buf, "STX", adr); break;
		case STX:	un_ext(buf, "STX", adr); break;

		case ABA:	un_imp(buf, "ABA", adr); break;

		case ADCA_imm:	un_imm(buf, "ADCA", adr); break;
		case ADCA_dir:	un_dir(buf, "ADCA", adr); break;
		case ADCA_idx:	un_idx(buf, "ADCA", adr); break;
		case ADCA:	un_ext(buf, "ADCA", adr); break;
		case ADCB_imm:	un_imm(buf, "ADCB", adr); break;
		case ADCB_dir:	un_dir(buf, "ADCB", adr); break;
		case ADCB_idx:	un_idx(buf, "ADCB", adr); break;
		case ADCB:	un_ext(buf, "ADCB", adr); break;

		case ADDA_imm:	un_imm(buf, "ADDA", adr); break;
		case ADDA_dir:	un_dir(buf, "ADDA", adr); break;
		case ADDA_idx:	un_idx(buf, "ADDA", adr); break;
		case ADDA:	un_ext(buf, "ADDA", adr); break;
		case ADDB_imm:	un_imm(buf, "ADDB", adr); break;
		case ADDB_dir:	un_dir(buf, "ADDB", adr); break;
		case ADDB_idx:	un_idx(buf, "ADDB", adr); break;
		case ADDB:	un_ext(buf, "ADDB", adr); break;

		case SBA:	un_imp(buf, "SBA", adr); break;

		case SBCA_imm:	un_imm(buf, "SBCA", adr); break;
		case SBCA_dir:	un_dir(buf, "SBCA", adr); break;
		case SBCA_idx:	un_idx(buf, "SBCA", adr); break;
		case SBCA:	un_ext(buf, "SBCA", adr); break;
		case SBCB_imm:	un_imm(buf, "SBCB", adr); break;
		case SBCB_dir:	un_dir(buf, "SBCB", adr); break;
		case SBCB_idx:	un_idx(buf, "SBCB", adr); break;
		case SBCB:	un_ext(buf, "SBCB", adr); break;

		case SUBA_imm:	un_imm(buf, "SUBA", adr); break;
		case SUBA_dir:	un_dir(buf, "SUBA", adr); break;
		case SUBA_idx:	un_idx(buf, "SUBA", adr); break;
		case SUBA:	un_ext(buf, "SUBA", adr); break;
		case SUBB_imm:	un_imm(buf, "SUBB", adr); break;
		case SUBB_dir:	un_dir(buf, "SUBB", adr); break;
		case SUBB_idx:	un_idx(buf, "SUBB", adr); break;
		case SUBB:	un_ext(buf, "SUBB", adr); break;

		case ANDA_imm:	un_imm(buf, "ANDA", adr); break;
		case ANDA_dir:	un_dir(buf, "ANDA", adr); break;
		case ANDA_idx:	un_idx(buf, "ANDA", adr); break;
		case ANDA:	un_ext(buf, "ANDA", adr); break;
		case ANDB_imm:	un_imm(buf, "ANDB", adr); break;
		case ANDB_dir:	un_dir(buf, "ANDB", adr); break;
		case ANDB_idx:	un_idx(buf, "ANDB", adr); break;
		case ANDB:	un_ext(buf, "ANDB", adr); break;

		case ORAA_imm:	un_imm(buf, "ORAA", adr); break;
		case ORAA_dir:	un_dir(buf, "ORAA", adr); break;
		case ORAA_idx:	un_idx(buf, "ORAA", adr); break;
		case ORAA:	un_ext(buf, "ORAA", adr); break;
		case ORAB_imm:	un_imm(buf, "ORAB", adr); break;
		case ORAB_dir:	un_dir(buf, "ORAB", adr); break;
		case ORAB_idx:	un_idx(buf, "ORAB", adr); break;
		case ORAB:	un_ext(buf, "ORAB", adr); break;

		case EORA_imm:	un_imm(buf, "EORA", adr); break;
		case EORA_dir:	un_dir(buf, "EORA", adr); break;
		case EORA_idx:	un_idx(buf, "EORA", adr); break;
		case EORA:	un_ext(buf, "EORA", adr); break;
		case EORB_imm:	un_imm(buf, "EORB", adr); break;
		case EORB_dir:	un_dir(buf, "EORB", adr); break;
		case EORB_idx:	un_idx(buf, "EORB", adr); break;
		case EORB:	un_ext(buf, "EORB", adr); break;

		case LSR_idx:	un_idx(buf, "LSR", adr); break;
		case LSR:	un_ext(buf, "LSR", adr); break;
		case LSRA:	un_imp(buf, "LSRA", adr); break;
		case LSRB:	un_imp(buf, "LSRB", adr); break;

		case ASR_idx:	un_idx(buf, "ASR", adr); break;
		case ASR:	un_ext(buf, "ASR", adr); break;
		case ASRA:	un_imp(buf, "ASRA", adr); break;
		case ASRB:	un_imp(buf, "ASRB", adr); break;

		case ASL_idx:	un_idx(buf, "ASL", adr); break;
		case ASL:	un_ext(buf, "ASL", adr); break;
		case ASLA:	un_imp(buf, "ASLA", adr); break;
		case ASLB:	un_imp(buf, "ASLB", adr); break;

		case ROR_idx:	un_idx(buf, "ROR", adr); break;
		case ROR:	un_ext(buf, "ROR", adr); break;
		case RORA:	un_imp(buf, "RORA", adr); break;
		case RORB:	un_imp(buf, "RORB", adr); break;

		case ROL_idx:	un_idx(buf, "ROL", adr); break;
		case ROL:	un_ext(buf, "ROL", adr); break;
		case ROLA:	un_imp(buf, "ROLA", adr); break;
		case ROLB:	un_imp(buf, "ROLB", adr); break;

		case BITA_imm:	un_imm(buf, "BITA", adr); break;
		case BITA_dir:	un_dir(buf, "BITA", adr); break;
		case BITA_idx:	un_idx(buf, "BITA", adr); break;
		case BITA:	un_ext(buf, "BITA", adr); break;
		case BITB_imm:	un_imm(buf, "BITB", adr); break;
		case BITB_dir:	un_dir(buf, "BITB", adr); break;
		case BITB_idx:	un_idx(buf, "BITB", adr); break;
		case BITB:	un_ext(buf, "BITB", adr); break;

		case CBA:	un_imp(buf, "CBA", adr); break;

		case CMPA_imm:	un_imm(buf, "CMPA", adr); break;
		case CMPA_dir:	un_dir(buf, "CMPA", adr); break;
		case CMPA_idx:	un_idx(buf, "CMPA", adr); break;
		case CMPA:	un_ext(buf, "CMPA", adr); break;
		case CMPB_imm:	un_imm(buf, "CMPB", adr); break;
		case CMPB_dir:	un_dir(buf, "CMPB", adr); break;
		case CMPB_idx:	un_idx(buf, "CMPB", adr); break;
		case CMPB:	un_ext(buf, "CMPB", adr); break;

		case CPX_imm:	un_imm_w(buf, "CPX", adr); break;
		case CPX_dir:	un_dir(buf, "CPX", adr); break;
		case CPX_idx:	un_idx(buf, "CPX", adr); break;
		case CPX:	un_ext(buf, "CPX", adr); break;

		case TST_idx:	un_idx(buf, "TST", adr); break;
		case TST:	un_ext(buf, "TST", adr); break;
		case TSTA:	un_imp(buf, "TSTA", adr); break;
		case TSTB:	un_imp(buf, "TSTB", adr); break;

		case BCC:	un_rel(buf, "BCC", adr); break;
		case BCS:	un_rel(buf, "BCS", adr); break;
		case BEQ:	un_rel(buf, "BEQ", adr); break;
		case BGE:	un_rel(buf, "BGE", adr); break;
		case BGT:	un_rel(buf, "BGT", adr); break;
		case BHI:	un_rel(buf, "BHI", adr); break;
		case BLE:	un_rel(buf, "BLE", adr); break;
		case BLS:	un_rel(buf, "BLS", adr); break;
		case BLT:	un_rel(buf, "BLT", adr); break;
		case BMI:	un_rel(buf, "BMI", adr); break;
		case BNE:	un_rel(buf, "BNE", adr); break;
		case BPL:	un_rel(buf, "BPL", adr); break;
		case BVC:	un_rel(buf, "BVC", adr); break;
		case BVS:	un_rel(buf, "BVS", adr); break;

		case BRA:	un_rel(buf, "BRA", adr); break;
		case BSR:	un_rel(buf, "BSR", adr); break;

		case JMP_idx:	un_idx(buf, "JMP", adr); break;
		case JMP:	un_ext(buf, "JMP", adr); break;
		case JSR_idx:	un_idx(buf, "JSR", adr); break;
		case JSR:	un_ext(buf, "JSR", adr); break;

		case RTS:	un_imp(buf, "RTS", adr); break;

		case 0x41:	un_imp(buf, "CH_OUT*", adr); break;
		case 0x51:	un_imp(buf, "CH_IN*", adr); break;

		case RTI:	un_imp(buf, "RTI", adr); break;
		case SWI:	un_imp(buf, "SWI", adr); break;
		case WAI:	un_imp(buf, "WAI", adr); break;

		default:	un_imp(buf, "?????", adr); break;
	}
	return buf;
}

byte mc6800::getA()
{
	return A;
}

byte mc6800::getB()
{
	return B;
}

word mc6800::getX()
{
	return X;
}

word mc6800::getSP()
{
	return SP;
}

word mc6800::getPC()
{
	return PC;
}
byte mc6800::getMem(word addr)
{
	return memr(addr);
}
int mc6800::getC()
{
	return c;
}

int mc6800::getV()
{
	return v;
}

int mc6800::getZ()
{
	return z;
}

int mc6800::getN()
{
	return n;
}

int mc6800::getI()
{
	return i;
}

int mc6800::getH()
{
	return h;
}

byte *mc6800::getMemPtr()
{
	return &MEM[0];
}
#endif

byte *mc6800::getRomPtr(int pag)
{
	if (pag >= 0) {
		pag &= 0xf;
		return ROMP[pag];
	} else return &BMEM[0];
}

void mc6800::reset()
{
	i = fWai = tick50 = IRQrequest = 0;
	PC = memr(0xfffe)<<8; PC |= memr(0xffff);
}

void mc6800::setDATETIME()
{
	union REGS regs;

	regs.h.ah=0x2c; int386(0x21,&regs,&regs);
	MEM[0x18]=regs.h.dl; MEM[0x19]=regs.h.dh;
	MEM[0x1a]=regs.h.cl; MEM[0x1b]=regs.h.ch;
	regs.h.ah=0x2a; int386(0x21,&regs,&regs);
	MEM[0x1c]=regs.h.dl; MEM[0x1d]=regs.h.dh;
	MEM[0x1e]=regs.h.ch; MEM[0x1f]=regs.h.cl;
	MEM[0xed00]=0xa5; MEM[0xed01]=0x5a;
}
